/***************************************build mod****************************************/
#pragma semicolon 1

#include <sourcemod>
#include <sdktools>
#include <vphysics>
#include <stocklib>
#include <matrixmath>
#undef REQUIRE_PLUGIN
#include <gravitygun>

#define PluginVersion "1.0.1.18"
#define SPAWNDISTANCE 200.0

public Plugin:myinfo = {

	name = "BuildMod",
	author = "javalia",
	description = "build mod(powered by asherkin technologe)",
	version = PluginVersion,
	url = "http://www.sourcemod.net/"
};

new entityvalidate[2048];//this will save entity referance of entity that are created by user
new entityowner[2048];//this will save entity owner`s userid! not client index!!!!

new Handle:cvargravitygunrestrict = INVALID_HANDLE;

//this restricts spawn cmd of client
//new Float:nextspawntime[MAXPLAYERS + 1];//not used too, just trash

new weldtargetentref[MAXPLAYERS + 1][2];//temp save for weld function
new lengthweldtargetentref[MAXPLAYERS + 1][2];//temp save for weld function , not used on code, just trash.

bool:isvalidmodel(const String:modelname[]){

	return (FileExists(modelname, true) || FileExists(modelname, false)) && (StrContains(modelname, ".mdl", false) != -1);

}

bool:clientcancontrolentity(client, entity){

	if( GetUserAdmin(client) != INVALID_ADMIN_ID){

		return true;

	}

	if((GetClientOfUserId(entityowner[entity]) == 0) ||
		(GetClientOfUserId(entityowner[entity]) == client && entityvalidate[entity] == EntIndexToEntRef(entity)) ||
		(entityvalidate[entity] != EntIndexToEntRef(entity))){

		return true;

	}else{

		return false;

	}

}

public OnPluginStart(){

	CreateConVar("buildmod_version", PluginVersion, "plugin info cvar", FCVAR_REPLICATED | FCVAR_NOTIFY);
	cvargravitygunrestrict = CreateConVar("buildmod_gravitygunmodrestrict", "1", "work with gravity gun plugin");

	LoadTranslations("buildmod.phrases");

	HookEvent("player_death", Event_PlayerDeath);

	//RegAdminCmd("sm_ragdoll", CommandRagDoll, ADMFLAG_GENERIC, "spawn a ragdoll with model file path specification");
	//RegAdminCmd("sm_rigid", CommandRigid, ADMFLAG_GENERIC, "spawn a rigid with model file path specification in prop_physics type");
	//RegAdminCmd("sm_rigid2", CommandRigid2, ADMFLAG_GENERIC, "spawn a rigid with model file path specification in prop_physics_override type");

	RegAdminCmd("sm_ragdoll", CommandRagDoll, 0, "spawn a ragdoll with model file path specification");
	RegAdminCmd("sm_rigid", CommandRigid, 0, "spawn a rigid with model file path specification in prop_physics type");
	RegAdminCmd("sm_rigid2", CommandRigid2, 0, "spawn a rigid with model file path specification in prop_physics_override type");
	RegAdminCmd("sm_rigid3", CommandRigid3, 0, "spawn a rigid with model file path specification in prop_physics_multiplayer type");

	RegAdminCmd("sm_fix", CommandDisableMotion, 0, "disable motion of entity");
	RegAdminCmd("sm_unfix", CommandEnableMotion, 0, "enable motion of entity");

	RegAdminCmd("sm_copy", CommandCopy, 0, "copy a rigid or ragdoll in auto detected entity type");
	RegAdminCmd("sm_copy1", CommandCopy1, 0, "copy a rigid in prop_physics type");
	RegAdminCmd("sm_copy2", CommandCopy2, 0, "copy a rigid in prop_physics_override type");

	RegAdminCmd("sm_delete", CommandDelete, 0, "kill entity");
	RegAdminCmd("sm_dissolve", CommandDissolve, 0, "dissolve entity");

	RegAdminCmd("sm_stop", CommandStop, 0, "stabilize entity");

	RegAdminCmd("sm_god", CommandGod, 0, "set entity to invincible stat");

	RegAdminCmd("sm_ungod", CommandUnGod, 0, "set entity to breakable stat");

	//RegAdminCmd("sm_fly", CommandFly, 0, "togglenoclip");//if u wanna use, enable this line
	RegAdminCmd("sm_setmass", CommandSetMass, 0, "set entity`s mass");

	RegAdminCmd("sm_setgravity", CommandSetGravity, 0, "set entity`s gravity");

	RegAdminCmd("sm_punt", CommandPunt, 0, "punt entity");

	RegAdminCmd("sm_targetname", CommandSetTargetName, 0, "set targetname of entity");//not so usefull at this version.

	RegAdminCmd("sm_weld", CommandWeld, 0, "weld two objects");

	RegAdminCmd("sm_wheel", CommandWheel, 0, "make wheel");

	//RegAdminCmd("sm_lengthweld", CommandLengthWeld, 0, "length weld two objects");

	//RegAdminCmd("sm_constraintsys", CommandConstraintSystem, 0);//dont use. not working at all. useleff.
	for (new client = 0; client <= MaxClients; client++)
	{
		OnClientPutInServer(client);
	}
}

public Action:OnClientGrabEntity(client, entity){

	if(!clientcancontrolentity(client, entity) && GetConVarBool(cvargravitygunrestrict)){

		return Plugin_Handled;

	}else{

		return Plugin_Continue;

	}

}

public Action:OnClientDragEntity(client, entity){

	if(!clientcancontrolentity(client, entity) && GetConVarBool(cvargravitygunrestrict)){

		return Plugin_Handled;

	}else{

		return Plugin_Continue;

	}

}

public Action:OnClientEmptyShootEntity(client, entity){

	if(!clientcancontrolentity(client, entity) && GetConVarBool(cvargravitygunrestrict)){

		return Plugin_Handled;

	}else{

		return Plugin_Continue;

	}

}

public Action:OnClientShootEntity(client, entity){

	if(!clientcancontrolentity(client, entity) && GetConVarBool(cvargravitygunrestrict)){

		return Plugin_Handled;

	}else{

		return Plugin_Continue;

	}

}

public OnClientPutInServer(client){

	weldtargetentref[client][0] = -1;
	weldtargetentref[client][1] = -1;
	lengthweldtargetentref[client][0] = -1;
	lengthweldtargetentref[client][1] = -1;

}

public Action:Event_PlayerDeath(Handle:Event, const String:Name[], bool:Broadcast){

	decl client;
	client = GetClientOfUserId(GetEventInt(Event, "userid"));

	weldtargetentref[client][0] = -1;
	weldtargetentref[client][1] = -1;

}

public Action:CommandRagDoll(client, args){

	if(args >= 1){

		decl String:modelname[256];

		GetCmdArg(1, modelname, sizeof(modelname));

		if(isvalidmodel(modelname)){
			PrecacheModel(modelname, true);
			decl Float:pos[3], Float:angle[3];

			if(getclientspawnaim(client, pos, angle)){

				new entity = CreateEntityByName("prop_ragdoll");

				if(entity != -1){

					entityvalidate[entity] = EntIndexToEntRef(entity);
					entityowner[entity] = GetClientUserId(client);

					DispatchKeyValue(entity, "model", modelname);
					DispatchSpawn(entity);

					TeleportEntity(entity, pos, angle, NULL_VECTOR);

					PrintToChat(client, "\x04%T", "ragdollspawned", client);

				}

			}

		}else{

			PrintToChat(client, "\x04%t", "invalid model path");

		}

	}else{

		PrintToChat(client, "%t", "smragdollusage");

	}

	return Plugin_Handled;

}

public Action:CommandRigid(client, args){

	if(args >= 1){

		decl String:modelname[256];

		GetCmdArg(1, modelname, sizeof(modelname));

		if(isvalidmodel(modelname)){
			PrecacheModel(modelname, true);
			decl Float:pos[3], Float:angle[3];

			if(getclientspawnaim(client, pos, angle)){

				new entity = CreateEntityByName("prop_physics");

				if(entity != -1){

					entityvalidate[entity] = EntIndexToEntRef(entity);
					entityowner[entity] = GetClientUserId(client);

					DispatchKeyValue(entity, "model", modelname);
					DispatchSpawn(entity);

					TeleportEntity(entity, pos, angle, NULL_VECTOR);

					PrintToChat(client, "\x04%t", "rigidspawned");

				}

			}

		}else{

			PrintToChat(client, "\x04%t", "invalid model path");

		}

	}else{

		PrintToChat(client, "%t", "smrigidusage");

	}

	return Plugin_Handled;

}

public Action:CommandRigid2(client, args){

	if(args >= 1){

		decl String:modelname[256];

		GetCmdArg(1, modelname, sizeof(modelname));

		if(isvalidmodel(modelname)){
			PrecacheModel(modelname, true);
			decl Float:pos[3], Float:angle[3];

			if(getclientspawnaim(client, pos, angle)){

				new entity = CreateEntityByName("prop_physics_override");

				if(entity != -1){

					entityvalidate[entity] = EntIndexToEntRef(entity);
					entityowner[entity] = GetClientUserId(client);

					DispatchKeyValue(entity, "model", modelname);
					DispatchSpawn(entity);

					TeleportEntity(entity, pos, angle, NULL_VECTOR);

					PrintToChat(client, "\x04%t", "rigidspawned");

				}

			}

		}else{

			PrintToChat(client, "\x04%t", "invalid model path");

		}

	}else{

		PrintToChat(client, "%t", "smrigid2usage");

	}

	return Plugin_Handled;

}
public Action:CommandRigid3(client, args){

	if(args >= 1){

		decl String:modelname[256];
		new String:arg2[32];

		GetCmdArg(1, modelname, sizeof(modelname));
		if (args >= 2)
		{
			GetCmdArg(2, arg2, sizeof(arg2));
			IntToString(StringToInt(arg2), arg2, sizeof(arg2));
		}
		else strcopy(arg2, sizeof(arg2), "0");

		if(isvalidmodel(modelname)){
			PrecacheModel(modelname, true);
			decl Float:pos[3], Float:angle[3];

			if(getclientspawnaim(client, pos, angle)){

				new entity = CreateEntityByName("prop_physics_multiplayer");

				if(entity != -1){

					entityvalidate[entity] = EntIndexToEntRef(entity);
					entityowner[entity] = GetClientUserId(client);

					DispatchKeyValue(entity, "model", modelname);
					DispatchKeyValue(entity, "physicsmode", arg2);
					DispatchKeyValue(entity, "spawnflags", "256");
					DispatchSpawn(entity);

					TeleportEntity(entity, pos, angle, NULL_VECTOR);

					PrintToChat(client, "\x04%t (multiplayer)", "rigidspawned");

				}

			}

		}else{

			PrintToChat(client, "\x04%t", "invalid model path");

		}

	}else{

		PrintToChat(client, "%t (sm_rigid3)", "smrigidusage");

	}

	return Plugin_Handled;

}
public Action:CommandDisableMotion(client, args){

	new aiment = GetClientAimEntity2(client);

	if(aiment != 0 && aiment != -1 && !isClientConnectedIngame(aiment) && clientcancontrolentity(client, aiment)){

		AcceptEntityInput(aiment, "DisableMotion");
		new Float:stopspeed[3] = {0.0, 0.0, 0.0};
		TeleportEntity(aiment, NULL_VECTOR, NULL_VECTOR, stopspeed);
		PrintToChat(client, "\x04%t", "disabledmotion");

	}

	return Plugin_Handled;

}

public Action:CommandEnableMotion(client, args){

	new aiment = GetClientAimEntity2(client);

	if(aiment != 0 && aiment != -1 && !isClientConnectedIngame(aiment) && clientcancontrolentity(client, aiment)){

		AcceptEntityInput(aiment, "EnableMotion");
		PrintToChat(client, "\x04%t", "enabledmotion");

	}

	return Plugin_Handled;

}

public Action:CommandCopy(client, args){

	new aiment = GetClientAimEntity2(client);

	if(aiment != 0 && aiment != -1){

		decl String:classname[64], String:modelname[256];

		GetEdictClassname(aiment, classname, sizeof(classname));
		GetEntPropString(aiment, Prop_Data, "m_ModelName", modelname, sizeof(modelname));

		if(StrContains(classname, "prop") != -1){

			decl Float:pos[3], Float:angle[3];

			if(getclientspawnaim(client, pos, angle)){

				new entity = CreateEntityByName(classname);

				entityvalidate[entity] = EntIndexToEntRef(entity);
				entityowner[entity] = GetClientUserId(client);

				DispatchKeyValue(entity, "model", modelname);
				DispatchSpawn(entity);

				TeleportEntity(entity, pos, angle, NULL_VECTOR);

				PrintToChat(client, "\x04%t", "copied");

			}

		}

	}

	return Plugin_Handled;

}

public Action:CommandCopy2(client, args){

	new aiment = GetClientAimEntity2(client);

	if(aiment != 0 && aiment != -1){

		decl String:classname[64], String:modelname[256];

		GetEdictClassname(aiment, classname, sizeof(classname));
		GetEntPropString(aiment, Prop_Data, "m_ModelName", modelname, sizeof(modelname));

		if(StrContains(classname, "prop") != -1){

			decl Float:pos[3], Float:angle[3];

			if(getclientspawnaim(client, pos, angle)){

				new entity = CreateEntityByName("prop_physics_override");

				entityvalidate[entity] = EntIndexToEntRef(entity);
				entityowner[entity] = GetClientUserId(client);

				DispatchKeyValue(entity, "model", modelname);
				DispatchSpawn(entity);

				TeleportEntity(entity, pos, angle, NULL_VECTOR);

				PrintToChat(client, "\x04%t", "copied");

			}

		}

	}

	return Plugin_Handled;

}

public Action:CommandCopy1(client, args){

	new aiment = GetClientAimEntity2(client);

	if(aiment != 0 && aiment != -1){

		decl String:classname[64], String:modelname[256];

		GetEdictClassname(aiment, classname, sizeof(classname));
		GetEntPropString(aiment, Prop_Data, "m_ModelName", modelname, sizeof(modelname));

		if(StrContains(classname, "prop") != -1){

			decl Float:pos[3], Float:angle[3];

			if(getclientspawnaim(client, pos, angle)){

				new entity = CreateEntityByName("prop_physics");

				entityvalidate[entity] = EntIndexToEntRef(entity);
				entityowner[entity] = GetClientUserId(client);

				DispatchKeyValue(entity, "model", modelname);
				DispatchSpawn(entity);

				TeleportEntity(entity, pos, angle, NULL_VECTOR);

				PrintToChat(client, "\x04%t", "copied");

			}

		}

	}

	return Plugin_Handled;

}

public Action:CommandDelete(client, args){

	new aiment = GetClientAimEntity2(client);

	if(aiment != 0 && aiment != -1 && !isClientConnectedIngame(aiment) && clientcancontrolentity(client, aiment)){

		AcceptEntityInput(aiment, "Kill");
		PrintToChat(client, "\x04%t", "deleted");

	}

	return Plugin_Handled;

}

public Action:CommandDissolve(client, args){

	new aiment = GetClientAimEntity2(client);

	if(aiment != 0 && aiment != -1 && !isClientConnectedIngame(aiment) && clientcancontrolentity(client, aiment)){

		decl String:targetname[128];
		Format(targetname, 64, "dissolvetarget%f%f", GetGameTime(), GetRandomFloat());

		DispatchKeyValue(aiment, "targetname", targetname);

		new dissolver = CreateEntityByName("env_entity_dissolver");

		decl String:dissolvetype[32];
		Format(dissolvetype, sizeof(dissolvetype), "%d", GetRandomInt(0, 3));

		if (dissolver != -1){

			DispatchKeyValue(dissolver, "dissolvetype", dissolvetype);
			DispatchKeyValue(dissolver, "target", targetname);
			AcceptEntityInput(dissolver, "Dissolve");
			AcceptEntityInput(dissolver, "kill");

			PrintToChat(client, "\x04%t", "dissolved");

		}

	}

	return Plugin_Handled;

}

public Action:CommandStop(client, args){

	new aiment = GetClientAimEntity2(client);

	if(aiment != 0 && aiment != -1 && clientcancontrolentity(client, aiment)){

		decl String:classname[64], String:modelname[256];

		GetEdictClassname(aiment, classname, sizeof(classname));
		GetEntPropString(aiment, Prop_Data, "m_ModelName", modelname, sizeof(modelname));

		if(StrContains(classname, "prop") != -1){

			new Float:stopspeed[3] = {0.0, 0.0, 0.0};
			TeleportEntity(aiment, NULL_VECTOR, NULL_VECTOR, stopspeed);

			PrintToChat(client, "\x04%t", "stabilized");

		}

	}

	return Plugin_Handled;

}

public Action:CommandGod(client, args){

	new aiment = GetClientAimEntity2(client);

	if(aiment != 0 && aiment != -1 && clientcancontrolentity(client, aiment)){

		decl String:classname[64], String:modelname[256];

		GetEdictClassname(aiment, classname, sizeof(classname));
		GetEntPropString(aiment, Prop_Data, "m_ModelName", modelname, sizeof(modelname));

		if(StrContains(classname, "prop") != -1){

			setTakeDamage(aiment, DAMAGE_NO);

			PrintToChat(client, "\x04%t", "invincible");

		}

	}

	return Plugin_Handled;

}

public Action:CommandUnGod(client, args){

	new aiment = GetClientAimEntity2(client);

	if(aiment != 0 && aiment != -1 && clientcancontrolentity(client, aiment)){

		decl String:classname[64];

		GetEdictClassname(aiment, classname, sizeof(classname));

		if(StrContains(classname, "prop") != -1){

			setTakeDamage(aiment, DAMAGE_YES);

			PrintToChat(client, "\x04%t", "notinvincible");

		}

	}

	return Plugin_Handled;

}

public Action:CommandFly(client, args){

	if(isClientConnectedIngameAlive(client)){

		if(GetEntityMoveType(client) == MOVETYPE_NOCLIP){

			SetEntityMoveType(client, MOVETYPE_WALK);
			PrintToChat(client, "\x04%t", "walkmode");

		}else if(GetEntityMoveType(client) == MOVETYPE_WALK){

			SetEntityMoveType(client, MOVETYPE_NOCLIP);
			PrintToChat(client, "\x04%t", "noclipmode");

		}

	}

	return Plugin_Handled;

}

public Action:CommandSetMass(client, args){

	if(args >= 1){

		decl String:masstoset[256];

		GetCmdArg(1, masstoset, sizeof(masstoset));

		new Float:massfloat = StringToFloat(masstoset);

		new aiment = GetClientAimEntity2(client);

		if(aiment != 0 && aiment != -1 && !isClientConnectedIngame(aiment) && entityisphysprop(aiment) && clientcancontrolentity(client, aiment)){

			if(massfloat >= 1.0){

				Phys_SetMass(aiment, massfloat);
				PrintToChat(client, "\x04%t", "setmass", massfloat);

			}

		}

	}

	return Plugin_Handled;

}

public Action:CommandPunt(client, args){

	if(args >= 1){

		decl String:powertopunt[256];

		GetCmdArg(1, powertopunt, sizeof(powertopunt));

		new Float:powerfloat = StringToFloat(powertopunt);

		new aiment = GetClientAimEntity2(client);

		if(aiment != 0 && aiment != -1 && !isClientConnectedIngame(aiment) && entityisphysprop(aiment) && clientcancontrolentity(client, aiment)){

			decl Float:clienteyeangle[3], Float:anglevector[3];
			GetClientEyeAngles(client, clienteyeangle);
			GetAngleVectors(clienteyeangle, anglevector, NULL_VECTOR, NULL_VECTOR);
			NormalizeVector(anglevector, anglevector);
			ScaleVector(anglevector, powerfloat);
			TeleportEntity(aiment, NULL_VECTOR, NULL_VECTOR, anglevector);
			PrintToChat(client, "\x04%t", "setvelocity");

		}

	}

	return Plugin_Handled;

}

public Action:CommandSetGravity(client, args){

	new aiment = GetClientAimEntity2(client);

	if(aiment != 0 && aiment != -1 && !isClientConnectedIngame(aiment) && clientcancontrolentity(client, aiment)){

		if(entityisphysprop(aiment)){

			if(Phys_IsGravityEnabled(aiment)){

				Phys_EnableGravity(aiment, false);
				PrintToChat(client, "\x04%t", "nogravity");

			}else{

				Phys_EnableGravity(aiment, true);
				PrintToChat(client, "\x04%t", "gravity");

			}

		}

	}

	return Plugin_Handled;

}

public Action:CommandSetTargetName(client, args){

	if(args >= 1){

		decl String:targetname[256];

		GetCmdArg(1, targetname, sizeof(targetname));

		new aiment = GetClientAimEntity2(client);

		if(aiment != 0 && aiment != -1 && !isClientConnectedIngame(aiment)){

			decl String:inputargs[128];
			Format(inputargs, 128, "targetname %s", targetname);
			SetVariantString(inputargs);
			AcceptEntityInput(aiment, "AddOutput");
			PrintToChat(client, "\x04%t", "settargetname", aiment, targetname);

		}

	}else{

		PrintToChat(client, "%t", "settargetnameusage");

	}

	return Plugin_Handled;

}

public Action:CommandConstraintSystem(client, args){

	if(args >= 1){

		decl String:targetname[256];

		GetCmdArg(1, targetname, sizeof(targetname));

		new constraintsystem = EntRefToEntIndex(CreateEntityByName("phys_constraintsystem"));

		if(constraintsystem != -1){

			DispatchKeyValue(constraintsystem, "targetname", targetname);
			DispatchSpawn(constraintsystem);
			PrintToChat(client, "\x04Created constraint system %d, set targetname to \"%s\"", constraintsystem, targetname);

		}

	}else{

		PrintToChat(client, "[SM] Usage: sm_constraintsys <targetname>");

	}

	return Plugin_Handled;

}

public Action:CommandWeld(client, args){

	if(EntRefToEntIndex(weldtargetentref[client][0]) == -1){

		new aiment = GetClientAimEntity2(client);

		if(aiment > 0 && clientcancontrolentity(client, aiment)){

			if(entityisphysprop(aiment) && (EntIndexToEntRef(aiment) != weldtargetentref[client][1])){

				weldtargetentref[client][0] = EntIndexToEntRef(aiment);

				PrintToChat(client, "\x04%t", "weldpointed");

			}

		}

	}else if(EntRefToEntIndex(weldtargetentref[client][1]) == -1){

		new aiment = GetClientAimEntity2(client);

		if(aiment > 0 && clientcancontrolentity(client, aiment)){

			if(entityisphysprop(aiment) && (EntIndexToEntRef(aiment) != weldtargetentref[client][0])){

				weldtargetentref[client][1] = EntIndexToEntRef(aiment);

				PrintToChat(client, "\x04%t", "weldpointed");

			}

		}

	}

	if(EntRefToEntIndex(weldtargetentref[client][0]) > 0 && EntRefToEntIndex(weldtargetentref[client][1]) > 0){

		Phys_CreateFixedConstraint(EntRefToEntIndex(weldtargetentref[client][0]), EntRefToEntIndex(weldtargetentref[client][1]), INVALID_HANDLE);
		weldtargetentref[client][0] = -1;
		weldtargetentref[client][1] = -1;
		PrintToChat(client, "\x04%t", "weldperform");

	}

	return Plugin_Handled;

}

public Action:CommandWheel(client, args){

	//code from asherkin`s example

	decl Float:eyePos[3], Float:eyeAng[3];

	GetClientEyePosition(client, eyePos);
	GetClientEyeAngles(client, eyeAng);

	new Handle:trace = TR_TraceRayFilterEx(eyePos, eyeAng, MASK_SHOT, RayType_Infinite, tracerayfilterdefault, client);

	if(TR_DidHit(trace) && TR_GetEntityIndex(trace)){

		new entIndex = TR_GetEntityIndex(trace);

		if(isClientConnectedIngameAlive(entIndex) && clientcancontrolentity(client, entIndex)){

			return Plugin_Handled;

		}

		new Float:hitPos[3];
		new Float:hitNormal[3];
		TR_GetEndPosition(hitPos, trace);
		TR_GetPlaneNormal(trace, hitNormal);

		new wheelIndex = CreateEntityByName("prop_physics_multiplayer");
		if (!IsModelPrecached("models/props_vehicles/tire001c_car.mdl")) PrecacheModel("models/props_vehicles/tire001c_car.mdl");
		DispatchKeyValue(wheelIndex, "model", "models/props_vehicles/tire001c_car.mdl");
		DispatchKeyValue(wheelIndex, "spawnflags", "256");
		DispatchKeyValueFloat(wheelIndex, "physdamagescale", 0.0);
		DispatchKeyValueFloat(wheelIndex, "ExplodeDamage", 0.0);
		DispatchKeyValueFloat(wheelIndex, "ExplodeRadius", 0.0);

		DispatchSpawn(wheelIndex);

		new Float:surfaceAng[3];
		GetVectorAngles(hitNormal, surfaceAng);

		new Float:wheelCenter[3]; // Should be calculating the width of the model for this.
		new Float:vecToAdd[3];
		CopyVector(hitNormal, vecToAdd);
		ScaleVector(vecToAdd, 5.0);
		AddVectors(hitPos, vecToAdd, wheelCenter);

		TeleportEntity(wheelIndex, wheelCenter, surfaceAng, NULL_VECTOR);

		Phys_CreateHingeConstraint(entIndex, wheelIndex, INVALID_HANDLE, hitPos, hitNormal);
		PrintToChat(client, "\x04Added wheel %d to entity %d\x01", wheelIndex, entIndex);

	}

	CloseHandle(trace);

	return Plugin_Handled;

}

public Action:CommandWeldLength(client, args){

	if(EntRefToEntIndex(lengthweldtargetentref[client][0]) == -1){

		new aiment = GetClientAimEntity2(client);

		if(aiment != 0 && aiment != -1){

			if(entityisphysprop(aiment) && (EntIndexToEntRef(aiment) != lengthweldtargetentref[client][1])){

				lengthweldtargetentref[client][0] = EntIndexToEntRef(aiment);

				PrintToChat(client, "\x04%t", "weldpointed");

			}

		}

	}else if(EntRefToEntIndex(lengthweldtargetentref[client][1]) == -1){

		new aiment = GetClientAimEntity2(client);

		if(aiment != 0 && aiment != -1){

			if(entityisphysprop(aiment) && (EntIndexToEntRef(aiment) != lengthweldtargetentref[client][0])){

				lengthweldtargetentref[client][1] = EntIndexToEntRef(aiment);

				PrintToChat(client, "\x04%t", "weldpointed");

			}

		}

	}

	if(EntRefToEntIndex(lengthweldtargetentref[client][0]) != -1 && EntRefToEntIndex(lengthweldtargetentref[client][1]) != -1){

		Phys_CreateFixedConstraint(EntRefToEntIndex(lengthweldtargetentref[client][0]), EntRefToEntIndex(lengthweldtargetentref[client][1]), INVALID_HANDLE);
//		new Float:entpos1[3], Float:entpos2[3], Float:length;
		//Phys_CreateLengthConstraint(referenceObject, attachedObject, const Float:refPosition[3], const Float:attachedPosition[3], Float:totalLength, Float:minLength = 0.0, Float:strength = 1.0, Float:forceLimit = 0.0, Float:torqueLimit = 0.0, Float:bodyMassScaleRef = 1.0, Float:bodyMassScaleAttached = 1.0, bool:isActive = true);
		lengthweldtargetentref[client][0] = -1;
		lengthweldtargetentref[client][1] = -1;
		PrintToChat(client, "\x04%t", "weldperform");

	}

	return Plugin_Handled;

}

stock bool:getclientspawnaim(client, Float:resultvecpos[3], Float:resultangle[3]){

	if(isClientConnectedIngameAlive(client)){

		decl Float:cleyepos[3], Float:cleyeangle[3], Float:eyeanglevector[3];
		GetClientEyePosition(client, cleyepos);
		GetClientEyeAngles(client, cleyeangle);

		new Handle:traceresulthandle = INVALID_HANDLE;

		traceresulthandle = TR_TraceRayFilterEx(cleyepos, cleyeangle, MASK_SOLID, RayType_Infinite, tracerayfilterdefault, client);

		if(TR_DidHit(traceresulthandle) == true){

			decl Float:endpos[3], Float:endtostart[3];
			TR_GetEndPosition(endpos, traceresulthandle);

			if(GetVectorDistance(cleyepos, endpos) <= SPAWNDISTANCE){

				resultvecpos[0] = endpos[0];
				resultvecpos[1] = endpos[1];
				resultvecpos[2] = endpos[2];

				MakeVectorFromPoints(endpos, cleyepos, endtostart);
				GetVectorAngles(endtostart, resultangle);

				return true;

			}else{

				GetAngleVectors(cleyeangle, eyeanglevector, NULL_VECTOR, NULL_VECTOR);
				NormalizeVector(eyeanglevector, eyeanglevector);
				ScaleVector(eyeanglevector, SPAWNDISTANCE);

				AddVectors(cleyepos, eyeanglevector, resultvecpos);

				MakeVectorFromPoints(endpos, cleyepos, endtostart);
				GetVectorAngles(endtostart, resultangle);

				return true;

			}

		}

		CloseHandle(traceresulthandle);

	}

	return false;

}

stock bool:entityisphysprop(entity){

	decl String:classname[64];

	GetEdictClassname(entity, classname, sizeof(classname));

	if(StrContains(classname, "prop") != -1){

		return true;

	}

	return false;

}

stock LockStatusCheckOnEntitySpawn(client, entity){

	entityvalidate[entity] = EntIndexToEntRef(entity);
	entityowner[entity] = GetClientUserId(client);

	if(lockmode[client]){

		entitylock[entity] = true;

	}

}

stock bool:IsClientCanEditEntity(client, entity){

	if(EntRefToEntIndex(entityvalidate[entity]) == entity){

		new owner = GetClientOfUserId(userid);

		if(owner != client && owner != 0){

			if(entitylock[entity]){

				return true;

			}

		}

	}

	return false;

}